package com.example.fuzzControll.aop;

import com.example.fuzzControll.annotion.NeedCut;
import com.example.fuzzControll.constents.LogicDeleteEnum;
import com.example.fuzzControll.constents.MissionStateEnum;
import com.example.fuzzControll.constents.TableClassEnum;
import com.example.fuzzControll.mapper.MissionInfoMapper;
import com.example.fuzzControll.pojo.vo.MissionInfo;
import com.example.fuzzControll.service.AflnetPersistenceService;
import com.example.fuzzControll.tools.GlobalParameters;
import lombok.extern.slf4j.Slf4j;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.Signature;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;
import org.aspectj.lang.reflect.MethodSignature;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.Ordered;
import org.springframework.stereotype.Component;

import java.lang.reflect.Method;
import java.util.Arrays;
import java.util.Date;
import java.util.List;


@Aspect
@Component
@Slf4j
public class IntegrationAop implements Ordered {


    @Pointcut(value = "@annotation(com.example.fuzzControll.annotion.NeedCut)")
    private void cut() {
    }

    @Before("cut()")
    private void before(JoinPoint point) {
        List<String> needProcess = Arrays.asList("aflnet");
        Signature signature = point.getSignature();
        MethodSignature methodSignature = null;
        if (!(signature instanceof MethodSignature)) {
            throw new IllegalArgumentException("该注解只能用于方法");
        }
        methodSignature = (MethodSignature) signature;
        Object target = point.getTarget();
        Method currentMethod = null;
        try {
            currentMethod = target.getClass().getMethod(methodSignature.getName(), methodSignature.getParameterTypes());
        } catch (NoSuchMethodException e) {
            log.error("NoSuchMethod!");
            e.printStackTrace();
            throw new RuntimeException(e);
        }
        NeedCut logotype = currentMethod.getAnnotation(NeedCut.class);
        if ("before".equals(logotype.moment())) {//需要进行处理
            if ("aflnet".equals(logotype.name())) {//aflnet测试信息存储
                int missionId = GlobalParameters.missionInfoMapper.selectTopMissionId() + 1;
                GlobalParameters.missionInfoMapper.insertMission(new MissionInfo(missionId, TableClassEnum.AFLNET.getTableId(), new Date(), GlobalParameters.aflnetData.get("missionName"),
                        MissionStateEnum.RUNNING.getStateCode(), 0L));
            }
        }
    }

    @Around("cut()")
    public Object around(ProceedingJoinPoint point) throws Throwable {

        Signature signature = point.getSignature();
        MethodSignature methodSignature = null;
        if (!(signature instanceof MethodSignature)) {
            throw new IllegalArgumentException("该注解只能用于方法");
        }
        methodSignature = (MethodSignature) signature;

        Object target = point.getTarget();
        Method currentMethod = target.getClass().getMethod(methodSignature.getName(), methodSignature.getParameterTypes());

        NeedCut logotype = currentMethod.getAnnotation(NeedCut.class);
//        if (datasource != null) {
//            DataSourceContextHolder.setDataSourceType(logotype.name());
//            log.debug("设置数据源为：" + datasource.name());
//        } else {
//            DataSourceContextHolder.setDataSourceType(DSEnum.DATA_SOURCE_CORE);
//            log.debug("设置数据源为：dataSourceCore");
//        }
//        try {
        return point.proceed();
//        } finally {
//            log.debug("清空数据源信息！");
//            DataSourceContextHolder.clearDataSourceType();
//        }
    }


    @Override
    public int getOrder() {
        return 1;
    }

}
